/*
 * amp_control.c
 *
 * Created: 10.09.2013 17:05:17
 *  Author: Orion
 */ 


#include <avr/io.h>
#include <avr/interrupt.h>

#include "config.h"
#include "softtimer.h"
#include "encoder.h"

extern timer_u SoftTimer;
extern enc_state_t enc_state;

int main(void)
{
    channels_t Channels[CHANNELS] = {};     //  ,    
    Channels[0].selected = 1;
    
    //config();
    
    EncoderInit();
   
    SoftTimerInit();
    
    DDRD = 0xFF;
    PIND = 0;
 
    sei();
    
    while(1)
    {
        //   
        
        if (SoftTimer.encRd.flag)
        {
            SoftTimer.encRd.flag = 0;
            EncoderCapture();
            SBI(ENC_INT_REG, ENC_INT_ENBL);      //     
        }
        if (enc_state.knob)
        {
            enc_state.knob = 0;
            for (uint8_t i = 0; i < CHANNELS - 1; i++)
            {
                if (Channels[i].selected)           //        
                {
                    Channels[i].selected = 0;       //        
                    Channels[i+1].selected = 1;
                    break;                          //     
                }
                Channels[0].selected = 1;           //    - ,        
                Channels[CHANNELS-1].selected = 0;  //      ,     ,  
            }                                       //   , ,      :)
            //SoftTimerSet(&SoftTimer.blink);
        }
        if (enc_state.inc)
        {
            for (uint8_t i = 0; i < CHANNELS; i++)
            {
                if (Channels[i].selected)
                {
                    Channels[i].value =
                    ((Channels[i].value + enc_state.inc)<=100 && (Channels[i].value + enc_state.inc)>=0)?
                    Channels[i].value + enc_state.inc:
                    Channels[i].value;
                }
            }
            PIND = Channels[0].value;
            enc_state.inc = 0;
            //SoftTimerSet(&SoftTimer.updChnl);
            //SoftTimerSet(&SoftTimer.lock);
        }
    }
    
    return 0;
}