/*
 * encoder.c
 *
 * Created: 11.09.2013 11:44:08
 *  Author: Orion
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>
#include "config.h"
#include "encoder.h"
#include "softtimer.h"

/************************************************************************/
/* Initialization                                                       */
/************************************************************************/

void EncoderInit(void)
{
    // Init pull-up resistors
    ENC_PORT |= 1<<ENC_PINA
             |  1<<ENC_PINB
             |  1<<ENC_KNOB;
    // Init interrupts
    //ENC_INT_MASK |= 1<<ENC_INT_KNOB
    //             |  1<<ENC_INT_PINA;
    //ENC_INT_REG  |= 1<<ENC_INT_ENBL;
}

void EncoderCapture()
{
    uint8_t _curr = ENC_PIN & (1<<ENC_PINA | 1<<ENC_PINB | 1<<ENC_KNOB);
    
    switch (_curr)          //       
    {
        case (1<<ENC_PINB):
        enc_state.inc = (enc_state.delay)? 10 : 1;
        enc_state.delay = 1;
        SoftTimerSet(&SoftTimer.speed);
        break;
        case (1<<ENC_PINA | 1<<ENC_PINB):
        enc_state.inc = (enc_state.delay)? -10: -1;
        enc_state.delay = 1;
        SoftTimerSet(&SoftTimer.speed);
        break;
        case (1<<ENC_KNOB):
        enc_state.knob = 1;
        break;
    }
}

//  

ISR(PCINT0_vect)
{
    extern timer_u SoftTimer;
    CBI(ENC_INT_REG, ENC_INT_ENBL);           //        
    //SoftTimerSet(ENC_RD, ENC_RD_DELAY);     //        
    SoftTimerSet(&SoftTimer.encRd);
}
