/*
 * encoder.h
 *
 * Created: 11.09.2013 11:43:22
 *  Author: Orion
 */ 


#ifndef ENCODER_H_
#define ENCODER_H_

#include <stdint.h>
#include "softtimer.h"

//    

#define _A          0
#define _B          1
#define _C          2
#define _D          3

#define _ENCPORT    _B

#if _ENCPORT == _B
  #define ENC_PIN     PINB
  #define ENC_PORT    PORTB
  #define ENC_PINA    0
  #define ENC_PINB    6
  #define ENC_KNOB    7

  #define ENC_INT_MASK    PCMSK0
  #define ENC_INT_PINA    ENC_PINA
  #define ENC_INT_KNOB    ENC_KNOB
  #define ENC_INT_REG     PCICR
  #define ENC_INT_ENBL    PCIE0
#endif

#if _ENCPORT == _D
  #define ENC_PIN     PIND
  #define ENC_PORT    PORTD
  #define ENC_PINA    0
  #define ENC_PINB    1
  #define ENC_KNOB    2

  #define ENC_INT_MASK    PCMSK2
  #define ENC_INT_PINA    ENC_PINA
  #define ENC_INT_KNOB    ENC_KNOB
  #define ENC_INT_REG     PCICR
  #define ENC_INT_ENBL    PCIE2
#endif

typedef struct
{
    uint8_t knob    : 1;    //    
    int8_t  inc;
    uint8_t delay   : 1;    //      
} enc_state_t;

enc_state_t enc_state;
extern timer_u SoftTimer;

void EncoderInit(void);
void EncoderCapture();

#endif /* ENCODER_H_ */