/*
 * softtimer.c
 *
 * Created: 11.09.2013 11:46:40
 *  Author: Orion
 */ 

#include <avr/interrupt.h>
#include "softtimer.h"

void SoftTimerInit()
{
    SoftTimer.encRd.delay       = 3;      //    
    SoftTimer.speed.delay       = 200;    //     
    
    TIMSK0  |= 1<<TOIE0                 //  System timer
            |  1<<OCIE0A;
    TCCR0A  |= 0<<WGM01;                //  Compare timer mode, non-PWM
    TCCR0B  |= 0<<CS02
            |  1<<CS01
            |  0<<CS00;                 //  start timer, divider 256
}

//   
void SoftTimerInt()
{
    for (uint8_t i = 0; i < MAX_NUM_TIMERS; i++)
    {
        if (!SoftTimer.timers[i].count) continue;
        SoftTimer.timers[i].count--;
        if (!SoftTimer.timers[i].count) SoftTimer.timers[i].flag = 1;
    }
};

void SoftTimerSet(timer_t *_timer)
{
    //cli();
    _timer->count = _timer->delay;
    //sei();
}

//   
ISR (TIMER0_OVF_vect)
{
    SoftTimerInt();
}
